<html>
<head>
<title>OGRE: OgreResource.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreResource.h</h1><a href="OgreResource_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef _Resource_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define _Resource_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreStringInterface_8h.html">OgreStringInterface.h</a>"</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00039"></a><a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">00039</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042     <span class="comment">// Forward declaration</span>
<a name="l00043"></a>00043     <span class="keyword">class </span><a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>;
<a name="l00044"></a>00044 
<a name="l00071"></a><a class="code" href="classOgre_1_1Resource.html">00071</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style...">StringInterface</a>
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073     <span class="keyword">public</span>:
<a name="l00074"></a>00074         <a class="code" href="OgrePrerequisites_8h.html#18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a> <span class="comment">// public to allow external locking</span>
<a name="l00075"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html">00075</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1Resource_1_1Listener.html">Listener</a>
<a name="l00076"></a>00076         {
<a name="l00077"></a>00077         <span class="keyword">public</span>:
<a name="l00078"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#082340c9150be4d1b0509fd235e26ddc">00078</a>             <a class="code" href="classOgre_1_1Resource_1_1Listener.html">Listener</a>() {}
<a name="l00079"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#087cbfc9a4ad6490b09884d482932945">00079</a>             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Resource_1_1Listener.html">Listener</a>() {}
<a name="l00080"></a>00080 
<a name="l00091"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#7e351c772904425efce5e94f0418e6ca">00091</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> backgroundLoadingComplete(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>*) {}
<a name="l00092"></a>00092             
<a name="l00093"></a>00093         };
<a name="l00094"></a>00094         
<a name="l00096"></a><a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572c">00096</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572c" title="Enum identifying the loading state of the resource.">LoadingState</a>
<a name="l00097"></a>00097         {
<a name="l00099"></a><a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572c28d463296cacdfc115dbc3fb02d00e94">00099</a>             LOADSTATE_UNLOADED,
<a name="l00101"></a><a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572cf138fc9087e0dc755bff08a83720cbb5">00101</a>             LOADSTATE_LOADING,
<a name="l00103"></a><a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572ca38cbef7605fc4bff6da2f34599ace8f">00103</a>             LOADSTATE_LOADED,
<a name="l00105"></a><a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572c4228d390b3a9ed614001db177d1f441e">00105</a>             LOADSTATE_UNLOADING
<a name="l00106"></a>00106         };
<a name="l00107"></a>00107     <span class="keyword">protected</span>:
<a name="l00109"></a><a class="code" href="classOgre_1_1Resource.html#79c8dbcaa3f5359186352418383e1046">00109</a>         <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* mCreator;
<a name="l00111"></a><a class="code" href="classOgre_1_1Resource.html#18a3db85a240eda9dfe741a46f2c01c9">00111</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mName;
<a name="l00113"></a><a class="code" href="classOgre_1_1Resource.html#416b0fb05b6c9f03e11d0d8c4e2cbeea">00113</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mGroup;
<a name="l00115"></a><a class="code" href="classOgre_1_1Resource.html#269fd910e51c66290e0ffe5c2ac134d3">00115</a>         <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> mHandle;
<a name="l00117"></a><a class="code" href="classOgre_1_1Resource.html#170f4e3111f1338b45bf55d2f497a4be">00117</a>         <span class="keyword">volatile</span> <a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572c" title="Enum identifying the loading state of the resource.">LoadingState</a> mLoadingState;
<a name="l00119"></a><a class="code" href="classOgre_1_1Resource.html#6b9f18275f5f5a4dc3b83f23027a5d78">00119</a>         <span class="keyword">volatile</span> <span class="keywordtype">bool</span> mIsBackgroundLoaded;
<a name="l00121"></a>00121         <a class="code" href="OgrePrerequisites_8h.html#2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mLoadingStatusMutex)
<a name="l00123"></a><a class="code" href="classOgre_1_1Resource.html#fdef34c49ee7a3b256672e3e4b183142">00123</a>         size_t mSize;
<a name="l00125"></a><a class="code" href="classOgre_1_1Resource.html#14dce433a68055e7683aa872c197d1d8">00125</a>         <span class="keywordtype">bool</span> mIsManual;
<a name="l00127"></a><a class="code" href="classOgre_1_1Resource.html#342fcd2c8c95309e12dea3c699f91c15">00127</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mOrigin;
<a name="l00129"></a><a class="code" href="classOgre_1_1Resource.html#11c91bed31936b5dec39e30d77498470">00129</a>         <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* mLoader;
<a name="l00130"></a>00130 
<a name="l00131"></a><a class="code" href="classOgre_1_1Resource.html#edf85fc311b08d402ec8bcdb145fdfd1">00131</a>         typedef std::list&lt;<a class="code" href="classOgre_1_1Resource_1_1Listener.html">Listener</a>*&gt; ListenerList;
<a name="l00132"></a><a class="code" href="classOgre_1_1Resource.html#94e78b7ae5be758c317ae1e8c4e14f1b">00132</a>         ListenerList mListenerList;
<a name="l00133"></a>00133         <a class="code" href="OgrePrerequisites_8h.html#2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mListenerListMutex)
<a name="l00134"></a>00134 
<a name="l00137"></a><a class="code" href="classOgre_1_1Resource.html#f16d869fa1c3671447a1e22ae6228242">00137</a>         <a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>() 
<a name="l00138"></a>00138             : mCreator(0), mHandle(0), mLoadingState(LOADSTATE_UNLOADED), 
<a name="l00139"></a>00139             mIsBackgroundLoaded(false), mSize(0), mIsManual(0), mLoader(0)
<a name="l00140"></a>00140         { 
<a name="l00141"></a>00141         }
<a name="l00142"></a>00142 
<a name="l00149"></a><a class="code" href="classOgre_1_1Resource.html#c21645684d207f29513228e061dec765">00149</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> preLoadImpl(<span class="keywordtype">void</span>) {}
<a name="l00156"></a><a class="code" href="classOgre_1_1Resource.html#0ac4960f2e4969be70ded84e35c7728d">00156</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> postLoadImpl(<span class="keywordtype">void</span>) {}
<a name="l00157"></a>00157 
<a name="l00161"></a><a class="code" href="classOgre_1_1Resource.html#318dc51074007c20d68db9b40c70da08">00161</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> preUnloadImpl(<span class="keywordtype">void</span>) {}
<a name="l00166"></a><a class="code" href="classOgre_1_1Resource.html#b0e94a1f17f20b3e3c6f3cf4a5aa8096">00166</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> postUnloadImpl(<span class="keywordtype">void</span>) {}
<a name="l00167"></a>00167 
<a name="l00171"></a>00171         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00175"></a>00175         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00177"></a>00177         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00178"></a>00178 
<a name="l00180"></a>00180         <span class="keyword">virtual</span> <span class="keywordtype">void</span> queueFireBackgroundLoadingComplete(<span class="keywordtype">void</span>);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     <span class="keyword">public</span>:
<a name="l00197"></a>00197         <a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> handle,
<a name="l00198"></a>00198             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00199"></a>00199 
<a name="l00205"></a>00205         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>();
<a name="l00206"></a>00206 
<a name="l00217"></a>00217         <span class="keyword">virtual</span> <span class="keywordtype">void</span> load(<span class="keywordtype">bool</span> backgroundThread = <span class="keyword">false</span>);
<a name="l00218"></a>00218 
<a name="l00224"></a>00224         <span class="keyword">virtual</span> <span class="keywordtype">void</span> reload(<span class="keywordtype">void</span>);
<a name="l00225"></a>00225 
<a name="l00228"></a><a class="code" href="classOgre_1_1Resource.html#adcaa41accf6256ecf6c402e4839c0e9">00228</a>         <span class="keywordtype">bool</span> isReloadable(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00229"></a>00229 <span class="keyword">        </span>{
<a name="l00230"></a>00230             <span class="keywordflow">return</span> !mIsManual || mLoader;
<a name="l00231"></a>00231         }
<a name="l00232"></a>00232 
<a name="l00235"></a><a class="code" href="classOgre_1_1Resource.html#784ac37435bd89e6e0e31e58e8da22bf">00235</a>         <span class="keywordtype">bool</span> isManuallyLoaded(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00236"></a>00236 <span class="keyword">        </span>{
<a name="l00237"></a>00237             <span class="keywordflow">return</span> mIsManual;
<a name="l00238"></a>00238         }
<a name="l00239"></a>00239 
<a name="l00243"></a>00243         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unload(<span class="keywordtype">void</span>);
<a name="l00244"></a>00244 
<a name="l00247"></a><a class="code" href="classOgre_1_1Resource.html#965e3586c6755f89259d1031a14523d7">00247</a>         <span class="keywordtype">size_t</span> getSize(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00248"></a>00248 <span class="keyword">        </span>{ 
<a name="l00249"></a>00249             <span class="keywordflow">return</span> mSize; 
<a name="l00250"></a>00250         }
<a name="l00251"></a>00251 
<a name="l00254"></a>00254         <span class="keyword">virtual</span> <span class="keywordtype">void</span> touch(<span class="keywordtype">void</span>);
<a name="l00255"></a>00255 
<a name="l00258"></a><a class="code" href="classOgre_1_1Resource.html#c53229433c56a309c72da721b15d37ef">00258</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00259"></a>00259 <span class="keyword">        </span>{ 
<a name="l00260"></a>00260             <span class="keywordflow">return</span> mName; 
<a name="l00261"></a>00261         }
<a name="l00262"></a>00262 
<a name="l00263"></a><a class="code" href="classOgre_1_1Resource.html#efd258479b788213275bbe1b54b52f85">00263</a>         <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> getHandle(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00264"></a>00264 <span class="keyword">        </span>{
<a name="l00265"></a>00265             <span class="keywordflow">return</span> mHandle;
<a name="l00266"></a>00266         }
<a name="l00267"></a>00267 
<a name="l00270"></a><a class="code" href="classOgre_1_1Resource.html#a2de2f45c5e800d11b3b2d5119d53eab">00270</a>         <span class="keywordtype">bool</span> isLoaded(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00271"></a>00271 <span class="keyword">        </span>{ 
<a name="l00272"></a>00272             <span class="comment">// No lock required to read this state since no modify</span>
<a name="l00273"></a>00273             <span class="keywordflow">return</span> (mLoadingState == LOADSTATE_LOADED); 
<a name="l00274"></a>00274         }
<a name="l00275"></a>00275 
<a name="l00279"></a><a class="code" href="classOgre_1_1Resource.html#a2e265ae571e26eb5e2c57a5fe17ad9c">00279</a>         <a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572c" title="Enum identifying the loading state of the resource.">LoadingState</a> isLoading()<span class="keyword"> const</span>
<a name="l00280"></a>00280 <span class="keyword">        </span>{
<a name="l00281"></a>00281             <span class="keywordflow">return</span> mLoadingState;
<a name="l00282"></a>00282         }
<a name="l00283"></a>00283 
<a name="l00286"></a><a class="code" href="classOgre_1_1Resource.html#8408ffbd3ddfaac116e8565d2163975a">00286</a>         <a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572c" title="Enum identifying the loading state of the resource.">LoadingState</a> getLoadingState()<span class="keyword"> const</span>
<a name="l00287"></a>00287 <span class="keyword">        </span>{
<a name="l00288"></a>00288             <span class="keywordflow">return</span> mLoadingState;
<a name="l00289"></a>00289         }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00303"></a><a class="code" href="classOgre_1_1Resource.html#da62272e0e10c5ca5f619a2cdc348594">00303</a>         <span class="keywordtype">bool</span> isBackgroundLoaded(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIsBackgroundLoaded; }
<a name="l00304"></a>00304 
<a name="l00313"></a><a class="code" href="classOgre_1_1Resource.html#126372a71844bda74011ccd5088f706c">00313</a>         <span class="keywordtype">void</span> setBackgroundLoaded(<span class="keywordtype">bool</span> bl) { mIsBackgroundLoaded = bl; }
<a name="l00314"></a>00314 
<a name="l00324"></a>00324         <span class="keywordtype">void</span> escalateLoading();
<a name="l00325"></a>00325 
<a name="l00329"></a>00329         <span class="keywordtype">void</span> addListener(Listener* lis);
<a name="l00330"></a>00330 
<a name="l00334"></a>00334         <span class="keywordtype">void</span> removeListener(Listener* lis);
<a name="l00335"></a>00335 
<a name="l00337"></a><a class="code" href="classOgre_1_1Resource.html#980cb848898544602746e82ffe5afe1b">00337</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getGroup(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mGroup; }
<a name="l00338"></a>00338 
<a name="l00346"></a>00346         <span class="keywordtype">void</span> changeGroupOwnership(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newGroup);
<a name="l00347"></a>00347 
<a name="l00349"></a><a class="code" href="classOgre_1_1Resource.html#b6e377a3964d566ea112fe63bf1d7678">00349</a>         <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* getCreator(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mCreator; }
<a name="l00356"></a><a class="code" href="classOgre_1_1Resource.html#45bc7dcdc46cb3fa7c12140cc57b5611">00356</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getOrigin(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOrigin; }
<a name="l00358"></a><a class="code" href="classOgre_1_1Resource.html#7e248a1cca0662418d4ab3f63c2e7cf6">00358</a>         <span class="keywordtype">void</span> _notifyOrigin(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; origin) { mOrigin = origin; }
<a name="l00359"></a>00359 
<a name="l00367"></a>00367         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _fireBackgroundLoadingComplete(<span class="keywordtype">void</span>);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369     };
<a name="l00370"></a>00370 
<a name="l00389"></a><a class="code" href="namespaceOgre.html#4697cc0c72aef3b488c7e058adf734ed">00389</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;Resource&gt;</a> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>;
<a name="l00390"></a>00390 
<a name="l00412"></a><a class="code" href="classOgre_1_1ManualResourceLoader.html">00412</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>
<a name="l00413"></a>00413     {
<a name="l00414"></a>00414     <span class="keyword">public</span>:
<a name="l00415"></a><a class="code" href="classOgre_1_1ManualResourceLoader.html#52b91457400f54642fd3c9e0182905f5">00415</a>         <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>() {}
<a name="l00416"></a><a class="code" href="classOgre_1_1ManualResourceLoader.html#64c9f1f9f2817de97321412c59fabb5a">00416</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>() {}
<a name="l00417"></a>00417 
<a name="l00421"></a>00421         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadResource(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>* resource) = 0;
<a name="l00422"></a>00422     };
<a name="l00423"></a>00423 }
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:55 2008
</p>
</body>
</html>
